Index: /trunk/kernel/fs/fatfs.c
===================================================================
--- /trunk/kernel/fs/fatfs.c	(revision 656)
+++ /trunk/kernel/fs/fatfs.c	(revision 657)
@@ -1909,193 +1395,1246 @@
 
 
-
-/////////////////////////////////////////////////////
-error_t fatfs_new_dentry( vfs_inode_t * parent_inode,
-                          char        * name,
-                          xptr_t        child_inode_xp )
-{
-    uint8_t      * entry;            // pointer on FAT32 directory entry (array of 32 bytes)
-    uint32_t       index;            // index of FAT32 directory entry in mapper
-    mapper_t     * mapper;           // pointer on directory mapper
-    uint32_t       cluster;          // directory entry cluster
-    uint32_t       size;             // directory entry size
-    bool_t         is_dir;           // directory entry type (file/dir)
-    xptr_t         root_xp;          // extended pointer on root of parent dentries
-    xptr_t         iter_xp;          // iterator for this list
-    cxy_t          child_inode_cxy;  // child inode cluster  
-    vfs_inode_t  * child_inode_ptr;  // child inode local pointer
-    xptr_t         dentry_xp;        // extended pointer on searched dentry descriptor
-    cxy_t          dentry_cxy;       // cluster identifier of dentry (must be local_cxy)
-    vfs_dentry_t * dentry_ptr;       // local pointer 
-    error_t        error;
-
-    char           parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
-
-// check arguments
-assert( (parent_inode   != NULL)       , "parent_inode is NULL\n" );
-assert( (name           != NULL)       , "name is NULL\n" );
-assert( (child_inode_xp != XPTR_NULL ) , "child_inode is NULL\n" );
-
-    // get child inode cluster and local pointer
-    child_inode_cxy = GET_CXY( child_inode_xp );
-    child_inode_ptr = GET_PTR( child_inode_xp );
-
-    // build extended pointer on root of list of parent dentries
-    root_xp = XPTR( child_inode_cxy , &child_inode_ptr->parents );
-
-// check child inode has at least one parent
-assert( (xlist_is_empty( root_xp ) == false ), "child inode must have one parent\n");
-
-#if DEBUG_FATFS_NEW_DENTRY
+//////////////////////////////////////////////////////////////////////////////////////////
+//              FATFS debug functions 
+//////////////////////////////////////////////////////////////////////////////////////////
+
+///////////////////////////////////
+void fatfs_display_ctx( cxy_t cxy )
+{
+    // get pointer on local FATFS context
+    vfs_ctx_t   * vfs_ctx = &fs_context[FS_TYPE_FATFS];
+	fatfs_ctx_t * ctx     = hal_remote_lpt( XPTR( cxy , &vfs_ctx->extend ) );
+
+    uint32_t fat_sectors       = hal_remote_l32( XPTR( cxy , &ctx->fat_sectors_count ) );
+    uint32_t sector_size       = hal_remote_l32( XPTR( cxy , &ctx->bytes_per_sector ) );
+    uint32_t sec_per_clus      = hal_remote_l32( XPTR( cxy , &ctx->sectors_per_cluster ) );
+    uint32_t fat_lba           = hal_remote_l32( XPTR( cxy , &ctx->fat_begin_lba ) );
+    uint32_t data_lba          = hal_remote_l32( XPTR( cxy , &ctx->cluster_begin_lba ) );
+    uint32_t fsinfo_lba        = hal_remote_l32( XPTR( cxy , &ctx->fs_info_lba ) );
+    uint32_t root_dir_clus     = hal_remote_l32( XPTR( cxy , &ctx->root_dir_cluster ) );
+    uint32_t free_clusters     = hal_remote_l32( XPTR( cxy , &ctx->free_clusters ) );
+    uint32_t free_cluster_hint = hal_remote_l32( XPTR( cxy , &ctx->free_cluster_hint ) );
+    void   * fat_mapper        = hal_remote_lpt( XPTR( cxy , &ctx->fat_mapper ) );
+    void   * fs_info_buffer    = hal_remote_lpt( XPTR( cxy , &ctx->fs_info_buffer ) );
+
+    printk("\n*** FAT context in cluster %x\n" 
+           "- fat_sectors       = %d\n"
+           "- sector size       = %d\n"
+           "- cluster size      = %d\n"
+           "- fat_lba           = %x\n"
+           "- data_lba          = %x\n"
+           "- fsinfo_lba        = %x\n"
+           "- root_dir_cluster  = %x\n"
+           "- free_clusters     = %x\n"
+           "- free_cluster_hint = %x\n"
+           "- fat_mapper        = %x\n"
+           "- fs_info_buffer    = %x\n",
+           cxy,
+           fat_sectors,
+           sector_size,
+           sector_size * sec_per_clus,
+           fat_lba,
+           data_lba,
+           fsinfo_lba,
+           root_dir_clus,
+           free_clusters,
+           free_cluster_hint,
+           fat_mapper,
+           fs_info_buffer );
+
+}  // end fatfs_display_ctx()
+
+//////////////////////////////////////////
+void fatfs_display_fat( uint32_t  min_slot,
+                        uint32_t  nb_slots )
+{
+    // one FAT mapper page contains 1024 slots = 128 lines of 8 slots
+
+    uint32_t   page_id;
+    uint32_t   line;
+    cxy_t      fat_cxy;         // FAT cluster
+    mapper_t * mapper;          // local pointer on FAT mapper
+    xptr_t     mapper_xp;       // extended pointer on fat_mapper
+    uint32_t   min_cluster_id;  // index of min slot to be displayed
+    uint32_t   min_page_id;     // index of min page to be displayed
+    uint32_t   min_line_id;     // index of min line in min page ( < 128 )
+    uint32_t   max_cluster_id;  // index of max slot to be displayed
+    uint32_t   max_page_id;     // index of max page to be displayed
+    uint32_t   max_line_id;     // index of max line in max page ( < 128 )
+
+    // compute min values
+    min_cluster_id = min_slot & 0xFFFFFFF8;
+    min_line_id    = (min_cluster_id & 0x3FF) >> 3;
+    min_page_id    = min_cluster_id >> 10;
+
+    // compute max values
+    max_cluster_id = min_slot + nb_slots - 1;
+    max_line_id    = (max_cluster_id & 0x3FF) >> 3;
+    max_page_id    = max_cluster_id >> 10;
+
+    // get pointer on local FATFS context
+    vfs_ctx_t   * vfs_ctx       = &fs_context[FS_TYPE_FATFS];
+    fatfs_ctx_t * loc_fatfs_ctx = (fatfs_ctx_t *)vfs_ctx->extend;
+
+    // get FAT cluster
+    fat_cxy = CONFIG_VFS_ROOT_CXY;
+
+    // get pointers on FAT mapper (in FAT cluster)
+    mapper    = loc_fatfs_ctx->fat_mapper;
+    mapper_xp = XPTR( fat_cxy , mapper );
+
+    // get pointer on FATFS context in FAT cluster
+    fatfs_ctx_t * fat_fatfs_ctx = hal_remote_lpt( XPTR( fat_cxy , &vfs_ctx->extend ) );
+ 
+    // get current value of hint and free_clusters
+    uint32_t hint = hal_remote_l32( XPTR( fat_cxy , &fat_fatfs_ctx->free_cluster_hint ) );
+    uint32_t free = hal_remote_l32( XPTR( fat_cxy , &fat_fatfs_ctx->free_clusters ) );
+
+    printk("\n***** FAT mapper / cxy %x / free_clusters %x / hint %x\n", fat_cxy, free, hint );
+
+    // scan all pages as required by min_page_id and max_page_id
+    for( page_id = min_page_id ; page_id <= max_page_id ; page_id++ )
+    {
+        // get extended pointer on requested page descriptor in FAT mapper 
+        xptr_t page_xp = mapper_get_fat_page( mapper_xp , page_id );
+
+        // get extended pointer on requested page base
+        xptr_t     base_xp  = ppm_page2base( page_xp );
+
+        // compute min_line & max_line in current page
+        uint32_t min_line = (page_id == min_page_id) ? min_line_id : 0;
+        uint32_t max_line = (page_id == max_page_id) ? max_line_id : 127;
+
+        // loop on lines in current page
+        for( line = min_line ; line <= max_line ; line++ )
+        {
+            printk("%x : %X | %X | %X | %X | %X | %X | %X | %X\n",
+            (page_id << 10) + (line <<3 ),
+            hal_remote_l32( base_xp + ((line<<5)      ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 4  ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 8  ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 12 ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 16 ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 20 ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 24 ) ),
+            hal_remote_l32( base_xp + ((line<<5) + 28 ) ) );
+        }
+    }
+}  // end fatfs_display_fat()
+
+/////////////////////////////////////
+error_t fatfs_check_free_info( void )
+{
+    error_t       error;
+    fatfs_ctx_t * fatfs_ctx_ptr;              // local pointer on fatfs context in cluster 0
+    uint32_t      ctx_free_clusters;          // number of free clusters from fatfs context
+    uint32_t      ctx_free_cluster_hint;      // free cluster hint from fatfs context
+    uint32_t      ioc_free_clusters;          // number of free clusters from fatfs context
+    uint32_t      ioc_free_cluster_hint;      // free cluster hint from fatfs context
+    uint32_t      fs_info_lba;                // lba of FS_INFO sector on IOC device
+    uint8_t     * fs_info_buffer;             // local pointer on FS_INFO buffer in cluster 0
+    xptr_t        fs_info_buffer_xp;          // extended pointer on FS_INFO buffer in cluster 0
+    uint8_t       tmp_buf[512];               // 512 bytes temporary buffer 
+    xptr_t        tmp_buf_xp;                 // extended pointer on temporary buffer
+
+#if DEBUG_FATFS_SYNC_FSINFO
 uint32_t   cycle = (uint32_t)hal_get_cycles();
 thread_t * this  = CURRENT_THREAD;
-vfs_inode_get_name( XPTR( local_cxy , parent_inode ) , parent_name );
-if( DEBUG_FATFS_NEW_DENTRY < cycle )
+if( DEBUG_FATFS_SYNC_FSINFO < cycle )
+printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, cycle );
+#endif
+
+    // get pointer on fatfs context in cluster 0
+    fatfs_ctx_ptr = hal_remote_lpt( XPTR( 0 , &fs_context[FS_TYPE_FATFS].extend ) );
+
+    // get "free_clusters" and "free_cluster_hint" from fatfs context in cluster 0
+    ctx_free_clusters     = hal_remote_l32( XPTR( 0 , &fatfs_ctx_ptr->free_clusters ) );
+    ctx_free_cluster_hint = hal_remote_l32( XPTR( 0 , &fatfs_ctx_ptr->free_cluster_hint ) );
+
+    // get fs_info_lba 
+    fs_info_lba = hal_remote_l32( XPTR( 0 , &fatfs_ctx_ptr->fs_info_lba ) );
+
+    // build extended pointer on temporary buffer
+    tmp_buf_xp = XPTR( local_cxy , tmp_buf );
+
+    // copy FS_INFO sector from IOC to local buffer
+    error = dev_ioc_sync_read( tmp_buf_xp , fs_info_lba , 1 );
+
+    if ( error )
+    {
+        printk("\n[ERROR] in %s : cannot access FS_INFO on IOC device\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get current values of "free_clusters" and "free_cluster_hint" from FS_INFO on IOC
+    ioc_free_clusters     = fatfs_get_remote_record( FS_FREE_CLUSTERS     , tmp_buf_xp );
+    ioc_free_cluster_hint = fatfs_get_remote_record( FS_FREE_CLUSTER_HINT , tmp_buf_xp );
+
+#if DEBUG_FATFS_SYNC_FSINFO
+if( DEBUG_FATFS_SYNC_FSINFO < cycle )
+printk("\n[%s] thread[%x,%x] / ctx_free %x / ioc_free %x / ctx_hint %x / ioc_hint %x\n",
+__FUNCTION__ , this->process->pid, this->trdid, 
+ctx_free_clusters, ioc_free_clusters, ctx_free_cluster_hint, ioc_free_cluster_hint );
+#endif
+
+    // check values
+    if( (ioc_free_clusters     != ctx_free_clusters) || 
+        (ioc_free_cluster_hint != ctx_free_cluster_hint) )
+    {
+        printk("\n[WARNING] in %s : unconsistent free clusters info\n"
+        " ioc_free %x / ctx_free %x / ioc_hint %x / ctx_hint %x\n",
+        __FUNCTION__, ioc_free_clusters, ctx_free_clusters,
+        ioc_free_cluster_hint, ctx_free_cluster_hint );
+
+        // get pointers on FS_INFO buffer in cluster 0
+        fs_info_buffer    = hal_remote_lpt( XPTR( 0 , &fatfs_ctx_ptr->fs_info_buffer ) );
+        fs_info_buffer_xp = XPTR( 0 , fs_info_buffer );
+
+        // update FS_INFO buffer in cluster 0 
+        fatfs_set_remote_record(FS_FREE_CLUSTERS    ,fs_info_buffer_xp,ctx_free_clusters );
+        fatfs_set_remote_record(FS_FREE_CLUSTER_HINT,fs_info_buffer_xp,ctx_free_cluster_hint);
+
+        // update the FS_INFO sector on IOC device
+        error = dev_ioc_sync_write( fs_info_buffer_xp , fs_info_lba , 1 );
+
+        if ( error )
+        {
+            printk("\n[ERROR] in %s : cannot update FS_INFO on IOC device\n", __FUNCTION__ );
+            return -1;
+        }
+    }
+
+#if DEBUG_FATFS_SYNC_FSINFO
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_FATFS_SYNC_FSINFO < cycle )
+printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, cycle );
+#endif
+
+    return 0;
+
+}  // end fatfs_check_free_info()
+
+
+
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// Generic API : the following functions are called by the kernel VFS
+//               and must be defined by all supported file systems.
+///////////////////////////////////////////////////////////////////////////////////////
+
+
+/////////////////////////////////////
+xptr_t  fatfs_ctx_alloc( cxy_t  cxy )
+{
+    kmem_req_t    req;
+
+    // allocate memory from remote cluster
+	req.type     = KMEM_KCM;
+	req.order    = bits_log2( sizeof(fatfs_ctx_t) );
+    req.flags    = AF_KERNEL | AF_ZERO;
+ 
+    return XPTR( cxy , kmem_remote_alloc( cxy , &req ) );
+
+}  //end faffs_ctx_alloc()
+
+///////////////////////////////////////////////
+error_t  fatfs_ctx_init( xptr_t  fatfs_ctx_xp )
+{
+    error_t       error;
+    kmem_req_t    req;
+    cxy_t         cxy;             // FATFS context cluster identifier
+    fatfs_ctx_t * fatfs_ctx_ptr;   // local pointer on FATFS context
+    uint8_t     * buffer;          // local pointer on 512 bytes buffer
+    xptr_t        buffer_xp;       // extended pointer on 512 bytes buffer
+    xptr_t        fat_mapper_xp;   // extended pointer on FAT mapper
+    mapper_t    * fat_mapper;      // local pointer on FAT mapper
+
+    // get FATFS context cluster and local pointer
+    cxy           = GET_CXY( fatfs_ctx_xp );        
+    fatfs_ctx_ptr = GET_PTR( fatfs_ctx_xp );
+    
+#if DEBUG_FATFS_CTX_INIT
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+if( DEBUG_FATFS_CTX_INIT < cycle )
+printk("\n[%s] thread[%x,%x] enter for fatfs_ctx (%x,%x) / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, cxy, fatfs_ctx_ptr , cycle );
+#endif
+
+    // allocate a 512 bytes buffer in remote cluster, used to store
+    // temporarily the BOOT sector, and permanently the FS_INFO sector
+	req.type    = KMEM_KCM;
+    req.order   = 9;                    // 512 bytes
+    req.flags   = AF_KERNEL | AF_ZERO;
+	buffer      = kmem_remote_alloc( cxy , &req );
+
+    if( buffer == NULL ) 
+    {
+        printk("\n[PANIC] in %s : cannot allocate buffer in cluster %x\n",
+        __FUNCTION__ , cxy );
+        return -1;
+    }
+     
+    // build extended pointer on buffer
+    buffer_xp = XPTR( cxy , buffer );
+
+    // load the BOOT record from device
+    error = dev_ioc_sync_read( buffer_xp , 0 , 1 );
+
+    if ( error )
+    {
+        printk("\n[PANIC] in %s : cannot access boot record\n", __FUNCTION__ );
+        return -1;
+    }
+
+#if (DEBUG_FATFS_CTX_INIT & 0x1)
+uint8_t bs[256];
+hal_remote_memcpy( XPTR( local_cxy , bs ) , buffer_xp , 256 );
+if( DEBUG_FATFS_CTX_INIT < cycle )
+putb( "boot record", bs , 256 );
+#endif
+
+    // get sector size from boot record
+    uint32_t sector_size = fatfs_get_remote_record( BPB_BYTSPERSEC , buffer_xp );
+
+    if ( sector_size != 512 )
+    {
+        printk("\n[PANIC] in %s : sector size must be 512 bytes\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get cluster size from boot record
+    uint32_t nb_sectors = fatfs_get_remote_record( BPB_SECPERCLUS , buffer_xp );
+
+    if ( nb_sectors != 8 )
+    {
+        printk("\n[PANIC] in %s : cluster size must be 8 sectors\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get number of FAT copies from boot record
+    uint32_t nb_fats = fatfs_get_remote_record( BPB_NUMFATS , buffer_xp );
+
+    if ( nb_fats != 1 )
+    {
+        printk("\n[PANIC] in %s : number of FAT copies must be 1\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get number of sectors in FAT from boot record
+    uint32_t fat_sectors = fatfs_get_remote_record( BPB_FAT32_FATSZ32 , buffer_xp );
+
+    if ( (fat_sectors & 0xF) != 0 )
+    {
+        printk("\n[PANIC] in %s : FAT size not multiple of 16 sectors\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get root cluster from boot record
+    uint32_t root_cluster = fatfs_get_remote_record( BPB_FAT32_ROOTCLUS , buffer_xp );
+
+    if ( root_cluster != 2 ) 
+    {
+        printk("\n[PANIC] in %s : root cluster index must be 2\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get FAT lba from boot record
+    uint32_t fat_lba = fatfs_get_remote_record( BPB_RSVDSECCNT , buffer_xp );
+
+    // get FS_INFO sector lba from boot record
+    uint32_t fs_info_lba = fatfs_get_remote_record( BPB_FAT32_FSINFO , buffer_xp );
+
+    // load the FS_INFO record from device
+    error = dev_ioc_sync_read( buffer_xp , fs_info_lba , 1 );
+
+    if ( error )
+    {
+        printk("\n[PANIC] in %s : cannot access FS_INFO record\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get free_clusters number from FS_INFO record
+    uint32_t free_clusters = fatfs_get_remote_record( FS_FREE_CLUSTERS , buffer_xp );
+
+    if ( free_clusters >= fat_sectors << 7 )
+    {
+        printk("\n[PANIC] in %s : unconsistent free_clusters\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // get free_cluster_hint from FS_INFO record
+    uint32_t free_hint = fatfs_get_remote_record( FS_FREE_CLUSTER_HINT , buffer_xp );
+
+    if ( free_hint >= fat_sectors << 7 )
+    {
+        printk("\n[PANIC] in %s : unconsistent free_cluster_hint\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // allocate a mapper for the FAT in remote cluster
+    fat_mapper_xp  = mapper_create( cxy , FS_TYPE_FATFS );
+
+    // get local pointer on FAT mapper
+    fat_mapper = GET_PTR( fat_mapper_xp );
+
+    if ( fat_mapper == NULL )
+    {
+        printk("\n[PANIC] in %s : no memory for FAT mapper in cluster %x\n",
+        __FUNCTION__ , cxy );
+        return -1;
+    }
+
+#if (DEBUG_FATFS_CTX_INIT & 0x1)
+if( DEBUG_FATFS_CTX_INIT < cycle )
+printk("\n[%s] sector_size %d / nb_sectors %d / fat_sectors %x / hint %x\n",
+__FUNCTION__, sector_size, nb_sectors, fat_sectors, free_hint );
+#endif
+
+    // the inode field is NULL for the FAT mapper
+    hal_remote_spt( XPTR( cxy , &fat_mapper->inode ) , NULL );
+
+    // initialize the FATFS context
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->fat_begin_lba       ), fat_lba );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->fat_sectors_count   ), fat_sectors );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->bytes_per_sector    ), sector_size );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->sectors_per_cluster ), nb_sectors );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->cluster_begin_lba   ), fat_lba + fat_sectors );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->root_dir_cluster    ), 2 );
+    hal_remote_spt( XPTR( cxy , &fatfs_ctx_ptr->fat_mapper          ), fat_mapper );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->fs_info_lba         ), fs_info_lba );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->free_clusters       ), free_clusters );
+    hal_remote_s32( XPTR( cxy , &fatfs_ctx_ptr->free_cluster_hint   ), free_hint );
+    hal_remote_spt( XPTR( cxy , &fatfs_ctx_ptr->fs_info_buffer      ), buffer );
+
+    // initialize FATFS lock
+    remote_rwlock_init( XPTR( cxy , &fatfs_ctx_ptr->lock ) , LOCK_FATFS_FAT );
+
+#if DEBUG_FATFS_CTX_INIT
+if( DEBUG_FATFS_CTX_INIT < cycle )
+printk("\n[%s]  thread[%x,%x] exit for fatfs_ctx (%x,%x)\n",
+__FUNCTION__, this->process->pid, this->trdid, cxy, fatfs_ctx_ptr );
+#endif
+
+	return 0;
+
+}  // end fatfs_ctx_init()
+
+//////////////////////////////////////////////
+void fatfs_ctx_destroy( xptr_t  fatfs_ctx_xp )
+{
+    kmem_req_t   req;
+    mapper_t   * fat_mapper;
+    uint8_t    * fs_info_buffer;
+
+    // get FATFS context cluster and local pointer
+    fatfs_ctx_t * fatfs_ctx_ptr = GET_PTR( fatfs_ctx_xp );
+    cxy_t         fatfs_ctx_cxy = GET_CXY( fatfs_ctx_xp );
+
+    // get pointer on FAT mapper
+    fat_mapper = hal_remote_lpt( XPTR( fatfs_ctx_cxy , &fatfs_ctx_ptr->fat_mapper ) );
+
+    // release FAT mapper
+    mapper_destroy( XPTR( fatfs_ctx_cxy , fat_mapper ) );
+
+    // get pointer on FS_INFO buffer
+    fs_info_buffer = hal_remote_lpt( XPTR( fatfs_ctx_cxy , &fatfs_ctx_ptr->fs_info_buffer ) );
+
+    // release FS_INFO buffer
+    req.type = KMEM_KCM;
+    req.ptr  = fs_info_buffer;
+    kmem_remote_free( fatfs_ctx_cxy , &req );
+
+    // release FATFS context descriptor
+    req.type = KMEM_KCM;
+    req.ptr  = fatfs_ctx_ptr;
+    kmem_remote_free( fatfs_ctx_cxy , &req );
+
+}  // end fatfs_ctx_destroy()
+
+/////////////////////////////////////////////////////////
+error_t fatfs_add_dentry( xptr_t         parent_inode_xp,
+                          vfs_dentry_t * dentry_ptr )
+{
+    error_t       error;
+    vfs_inode_t * parent_inode_ptr;   // parent inode local pointer
+    cxy_t         parent_cxy;         // pparent inode cluster
+    xptr_t        child_inode_xp;     // extended pointer on child inode 
+    cxy_t         child_cxy;          // child inode cluster
+    vfs_inode_t * child_inode_ptr;    // child inode local pointer
+    uint32_t      length;             // dentry name length
+    uint32_t      nb_lfn;             // number or required LFN
+    char          sfn[11];            // buffer for SFN name
+    uint8_t       checksum;           // name checksum 
+    mapper_t    * mapper_ptr;         // local pointer on parent directory mapper
+    xptr_t        mapper_xp;          // extended pointer on parent directory mapper
+    uint32_t      size;               // child inode size
+    uint32_t      type;               // child inode type
+    void        * extend;             // child inode extension
+    uint32_t      cluster_id;         // child inode first cluster_id in FATFS 
+
+    char          child_name[CONFIG_VFS_MAX_NAME_LENGTH];
+
+    uint8_t       buf[32];            // local buffer for one FAT32 directory entry
+ 
+// check arguments
+assert( (parent_inode_xp != XPTR_NULL) , "parent_inode_xp argument is NULL\n" );
+assert( (dentry_ptr      != NULL)      , "dentry_ptr argument is NULL\n" );
+
+    // get directory inode cluster and local pointer 
+    parent_cxy       = GET_CXY( parent_inode_xp );
+    parent_inode_ptr = GET_PTR( parent_inode_xp );
+
+    // get extended pointers on child inode
+    child_inode_xp  = hal_remote_l64( XPTR( parent_cxy , &dentry_ptr->child_xp ) );
+    child_cxy       = GET_CXY( child_inode_xp );
+    child_inode_ptr = GET_PTR( child_inode_xp );
+
+    // get a local copy of the child name
+    vfs_inode_get_name( child_inode_xp  , child_name );
+
+#if DEBUG_FATFS_ADD_DENTRY
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+char       parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
+vfs_inode_get_name( parent_inode_xp , parent_name );
+if( DEBUG_FATFS_ADD_DENTRY < cycle )
+printk("\n[%s]  thread[%x,%x] enter for <%s> in <%s> directory / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name, cycle );
+#endif
+
+    // get pointers on parent directory mapper
+    mapper_ptr = hal_remote_lpt( XPTR( parent_cxy , &parent_inode_ptr->mapper ) );
+    mapper_xp  = XPTR( parent_cxy , mapper_ptr );
+
+#if (DEBUG_FATFS_ADD_DENTRY & 1)
+mapper_display_page( mapper_xp , 0 , 512 );
+#endif
+
+    // get relevant infos from child inode
+    type       = hal_remote_l32( XPTR( child_cxy , &child_inode_ptr->type ) );
+    size       = hal_remote_l32( XPTR( child_cxy , &child_inode_ptr->size ) );
+    extend     = hal_remote_lpt( XPTR( child_cxy , &child_inode_ptr->extend ) );
+    cluster_id = (uint32_t)(intptr_t)extend;
+
+    // analyse child name
+    error = fatfs_name_format( child_name,
+                               &length,
+                               &nb_lfn,
+                               sfn,
+                               &checksum );
+    if ( error )
+    {
+        printk("\n[ERROR] in %s : dentry name > 31 bytes\n", __FUNCTION__ );
+        return -1;
+    }
+                               
+    // Search end of directory with two embedded loops:
+    // - scan the pages in the mapper
+    // - scan the entries in each page to find NO_MORE_ENTRY
+
+    xptr_t     page_xp;                 // extended pointer on page descriptor
+    xptr_t     base_xp;                 // extended pointer on page base
+
+    // initialise loop variables
+    uint32_t   page_id = 0;             // page index in mapper
+    uint32_t   offset  = 0;             // position in page
+    uint32_t   found   = 0;             // NO_MORE_ENTRY found
+
+    // loop on pages in mapper
+    while ( found == 0 )
+    {
+        // get extended pointer on page descriptor in mapper 
+        page_xp  = mapper_get_page( mapper_xp , page_id );
+
+        if ( page_xp == XPTR_NULL )
+        {
+            printk("\n[ERROR] in %s : cannot extend directory mapper\n",
+            __FUNCTION__ );
+            return -1;
+        }
+        
+        // get pointer on page base
+        base_xp = ppm_page2base( page_xp );
+
+        // loop on directory entries in this page
+        while ( (offset < 4096) && (found == 0) )
+        {
+            if ( fatfs_get_remote_record( LDIR_ORD, (base_xp + offset) ) == NO_MORE_ENTRY )
+            {
+                found = 1;
+            }  
+            else
+            {
+                offset = offset + 32;
+            }
+        }  // end loop on entries
+
+        if ( found == 0 )
+        {
+            page_id++;
+            offset = 0;
+        }
+    }  // end loop on pages
+
+#if (DEBUG_FATFS_ADD_DENTRY & 1)
+if( DEBUG_FATFS_ADD_DENTRY < cycle )
+printk("\n[%s]  thread[%x,%x] found NO_MORE_ENTRY : page_id %d / offset %d\n",
+__FUNCTION__, this->process->pid, this->trdid, page_id, offset );
+#endif
+
+    // Modify the directory mapper: depending on the name length,
+    // the new child requires to write (3, 4, or 5) directory entries.
+    // We build one complete directory entry in a local buffer
+    // before copying it the remote mapper. We use use a 5 steps FSM 
+    // (one state per entry to be written), that is traversed as :
+    // LFN3 -> LFN2 -> LFN1 -> NORMAL -> NOMORE 
+    // At most two pages are modified:
+    // - the page containing the NO_MORE_ENTRY is always modified
+    // - the following page can be modified if the name spread on two pages.
+
+    uint32_t step;          // FSM state
+
+    if      ( nb_lfn == 1 ) step = 3;
+    else if ( nb_lfn == 2 ) step = 4;
+    else if ( nb_lfn == 3 ) step = 5;
+    
+    uint32_t   i;           // byte index in one 32 bytes directory
+    uint32_t   c;           // character index in name
+
+    while ( step )   
+    {
+        // this block is only executed when the new name spread 
+        // on two pages, and we need to access a new page in mapper
+        if ( offset >= 4096 )
+        {
+            // copy the modified page to IOC device
+            error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );   
+
+            if ( error )
+            {
+                printk("\n[ERROR] in %s : cannot update directory on device\n",
+                __FUNCTION__ );
+                return -1;
+            }
+
+            // get the next page in directory mapper
+            page_xp  = mapper_get_page( mapper_xp , page_id + 1 );
+
+            if ( page_xp == XPTR_NULL )
+            {
+                printk("\n[ERROR] in %s : cannot extend directory mapper\n",
+                __FUNCTION__ );
+                return -1;
+            }
+        
+            // get pointer on page base
+            base_xp = ppm_page2base( page_xp );
+            
+            // update offset
+            offset = 0;
+        }
+
+#if (DEBUG_FATFS_ADD_DENTRY & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_FATFS_ADD_DENTRY < cycle )
+printk("\n[%s] FSM step = %d / offset = %x / nb_lfn = %d / cycle %d\n",
+__FUNCTION__, step, offset, nb_lfn, cycle );
+#endif
+
+        // write one FATFS directory entry (32 bytes) per iteration
+        switch ( step )
+        {
+            case 5:   // write LFN3 entry
+            {
+                c = 26;
+
+                // write 32 bytes in local buf
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if (i == 0)
+                    {
+                        if ( nb_lfn == 3) buf[i] = 0x43;
+                        else              buf[i] = 0x03;
+                    }
+                    else if ( ( ((i >= 1 ) && (i<=10) && ((i&1)==1))   ||
+                                ((i >= 14) && (i<=25) && ((i&1)==0))   ||
+                                ((i >= 28) && (i<=31) && ((i&1)==0)) ) &&
+                              ( c < length ) )
+                    {
+                                          buf[i] = child_name[c];
+                                          c++;
+                    }
+                    else if (i == 11)     buf[i] = 0x0F;
+                    else if (i == 13)     buf[i] = checksum;
+                    else                  buf[i] = 0x00;
+                }
+
+                // copy 32 bytes from local buffer to remote mapper
+                hal_remote_memcpy( base_xp + offset , XPTR( local_cxy  , buf ) , 32 );
+
+                step--;
+                break;
+            }
+            case 4:   // write LFN2 entry  
+            {
+                c = 13;
+
+                // write 32 bytes in local buf
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if (i == 0)
+                    {
+                        if ( nb_lfn == 2) buf[i] = 0x42;
+                        else              buf[i] = 0x02;
+                    }
+                    else if ( ( ((i >= 1 ) && (i<=10) && ((i&1)==1))   ||
+                                ((i >= 14) && (i<=25) && ((i&1)==0))   ||
+                                ((i >= 28) && (i<=31) && ((i&1)==0)) ) &&
+                              ( c < length ) )
+                    {
+                                          buf[i] = child_name[c];
+                                          c++;
+                    }
+                    else if (i == 11)     buf[i] = 0x0F;
+                    else if (i == 13)     buf[i] = checksum;
+                    else                  buf[i] = 0x00;
+                }
+
+                // copy 32 bytes from local buffer to remote mapper
+                hal_remote_memcpy( base_xp + offset , XPTR( local_cxy  , buf ) , 32 );
+
+                step--;
+                break;
+            }
+            case 3:   // Write LFN1 entry   
+            {
+                c = 0;
+
+                // write 32 bytes in local buf
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if (i == 0)
+                    {
+                        if ( nb_lfn == 1) buf[i] = 0x41;
+                        else              buf[i] = 0x01;
+                    }
+                    else if ( ( ((i >= 1 ) && (i<=10) && ((i&1)==1))   ||
+                                ((i >= 14) && (i<=25) && ((i&1)==0))   ||
+                                ((i >= 28) && (i<=31) && ((i&1)==0)) ) &&
+                              ( c < length ) )
+                    {
+                                          buf[i] = child_name[c];
+                                          c++;
+                    }
+                    else if (i == 11)     buf[i] = 0x0F;
+                    else if (i == 13)     buf[i] = checksum;
+                    else                  buf[i] = 0x00;
+                }
+
+                // copy 32 bytes from local buffer to remote mapper
+                hal_remote_memcpy( base_xp + offset , XPTR( local_cxy  , buf ) , 32 );
+
+                step--;
+                break;
+            }
+            case 2:   // write NORMAL entry     
+            {
+                // write 32 bytes in local buf
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if      ( i < 11 )                               // 8.3 SFN
+                    {
+                                          buf[i] = sfn[i];
+                    }
+                    else if (i == 11)                                // ATTR
+                    {
+                        if (type == INODE_TYPE_DIR)  buf[i] = 0x10;
+                        else                         buf[i] = 0x20;
+                    }
+                    else if (i == 20)     buf[i] = cluster_id>>16;   // cluster.B2
+                    else if (i == 21)     buf[i] = cluster_id>>24;   // cluster.B3
+                    else if (i == 26)     buf[i] = cluster_id>>0;    // cluster.B0
+                    else if (i == 27)     buf[i] = cluster_id>>8;    // cluster.B1
+                    else if (i == 28)     buf[i] = size>>0;          // size.B0
+                    else if (i == 29)     buf[i] = size>>8;          // size.B1
+                    else if (i == 30)     buf[i] = size>>16;         // size.B2
+                    else if (i == 31)     buf[i] = size>>24;         // size.B3
+                    else                  buf[i] = 0x00;
+                }
+
+                // copy 32 bytes from local buffer to remote mapper
+                hal_remote_memcpy( base_xp + offset , XPTR( local_cxy  , buf ) , 32 );
+
+                // set the dentry "extend" field 
+                hal_remote_spt( XPTR( parent_cxy , &dentry_ptr->extend ),
+                                (void *)(intptr_t)(((page_id << 12) + offset) >> 5 ) );
+                step--;
+                break;
+            }
+            case 1:   // write NOMORE entry  
+            {
+                hal_remote_s32( base_xp + offset , 0 );
+
+                step--;
+                break;
+            }
+
+        } // end switch step
+
+        offset += 32;
+
+    } // end while     
+
+    // copy the modified page to the IOC device
+    error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );   
+
+    if ( error )
+    {
+        printk("\n[ERROR] in %s : cannot update directory on device\n",
+        __FUNCTION__ );
+        return -1;
+    }
+
+#if DEBUG_FATFS_ADD_DENTRY
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_FATFS_ADD_DENTRY < cycle )
+printk("\n[%s]  thread[%x,%x] exit for <%s> in <%s> directory\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name );
+#endif
+
+#if (DEBUG_FATFS_ADD_DENTRY & 1)
+mapper_display_page( mapper_xp , 0 , 512 );
+#endif
+
+    return 0;
+
+}  // end fatfs_add_dentry()
+
+////////////////////////////////////////////////////////////
+error_t fatfs_remove_dentry( xptr_t         parent_inode_xp,
+                             vfs_dentry_t * dentry_ptr )
+{
+    error_t       error;
+    vfs_inode_t * parent_inode_ptr;   // parent inode local pointer
+    cxy_t         parent_cxy;         // pparent inode cluster
+    xptr_t        child_inode_xp;     // extended pointer on child inode 
+    cxy_t         child_cxy;          // child inode cluster
+    vfs_inode_t * child_inode_ptr;    // child inode local pointer
+    xptr_t        mapper_xp;          // extended pointer on mapper
+    mapper_t    * mapper_ptr;         // local pointer on mapper
+    xptr_t        page_xp;            // extended pointer on mapper page descriptor
+    xptr_t        base_xp;            // extended pointer on mapper page base
+    uint32_t      dentry_id;          // FAT32 directory entry index
+    uint32_t      page_id;            // page index in directory mapper
+    uint32_t      offset;             // offset in this mapper page
+
+    char          child_name[CONFIG_VFS_MAX_NAME_LENGTH];
+
+// check arguments
+assert( (parent_inode_xp != XPTR_NULL) , "parent_inode_xp argument is NULL\n" );
+assert( (dentry_ptr      != NULL)      , "dentry_ptr argument is NULL\n" );
+
+    // get directory inode cluster and local pointer 
+    parent_cxy       = GET_CXY( parent_inode_xp );
+    parent_inode_ptr = GET_PTR( parent_inode_xp );
+
+    // get extended pointers on child inode
+    child_inode_xp  = hal_remote_l64( XPTR( parent_cxy , &dentry_ptr->child_xp ) );
+    child_cxy       = GET_CXY( child_inode_xp );
+    child_inode_ptr = GET_PTR( child_inode_xp );
+
+    // get a local copy of the child name
+    vfs_inode_get_name( child_inode_xp  , child_name );
+
+#if DEBUG_FATFS_REMOVE_DENTRY
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+char       parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
+vfs_inode_get_name( parent_inode_xp , parent_name );
+if( DEBUG_FATFS_REMOVE_DENTRY < cycle )
+printk("\n[%s]  thread[%x,%x] enter for <%s> in <%s> directory / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name, cycle );
+#endif
+
+    // get pointers on directory mapper
+    mapper_ptr = hal_remote_lpt( XPTR( parent_cxy , &parent_inode_ptr->mapper ) );
+    mapper_xp  = XPTR( parent_cxy , mapper_ptr );
+
+    // compute number of LFN entries
+    uint32_t nb_lfn;
+    uint32_t name_length = strlen( child_name );
+
+    if      ( name_length <= 13 ) nb_lfn  = 1;
+    else if ( name_length <= 26 ) nb_lfn  = 2;
+    else                          nb_lfn  = 3;
+
+    // We must invalidate (2,3,4) 32 bytes entries:
+    // - the NORMAL entry, registered in dentry->extend.
+    // - the (1,2,3) preceding LFN entries.
+    // At most two pages are modified:
+    // - the page containing the NORMAL entry is always modified.
+    // - the preceding page is modified when the name spread on two pages. 
+
+    // get NORMAL entry index from dentry extension 
+    dentry_id  = (uint32_t)(intptr_t)hal_remote_lpt( XPTR( parent_cxy , &dentry_ptr->extend ) ); 
+
+    // get page index and offset in parent directory mapper
+    page_id  = dentry_id >> 7;
+    offset   = (dentry_id & 0x7F)<<5;
+
+#if DEBUG_FATFS_REMOVE_DENTRY & 1
+if( DEBUG_FATFS_REMOVE_DENTRY < cycle )
+printk("\n[%s] dentry_id %x / page_id %x / offset %x\n",
+__FUNCTION__, dentry_id, page_id, offset );
+#endif
+
+    // get extended pointer on page descriptor 
+    page_xp  = mapper_get_page( mapper_xp , page_id );
+
+    if ( page_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s : cannot access directory mapper\n", __FUNCTION__ );
+        return -1;
+    }
+        
+    // get extended pointer on page base
+    base_xp = ppm_page2base( page_xp );
+
+    // invalidate NORMAL entry in directory cache
+    hal_remote_sb( base_xp + offset , 0xE5 );
+
+    // invalidate LFN entries
+    while ( nb_lfn )
+    {
+        // this block is only executed when the removed name
+        // spread on two mapper pages
+        if (offset == 0)  // we must load page (page_id - 1)
+        {
+            // copy the modified page to the IOC device
+            error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );   
+
+            if ( error )
+            {
+                printk("\n[ERROR] in %s : cannot update directory on device\n",
+                __FUNCTION__ );
+                return -1;
+            }
+
+            // get extended pointer on page descriptor 
+            page_xp  = mapper_get_page( mapper_xp , page_id );
+
+            if ( page_xp == XPTR_NULL )
+            {
+                printk("\n[ERROR] in %s : cannot access directory mapper\n", __FUNCTION__ );
+                return -1;
+            }
+        
+            // get extended pointer on page base
+            base_xp = ppm_page2base( page_xp );
+
+            // update offset
+            offset = 4096;
+        }
+
+        offset = offset - 32;
+
+// check for LFN entry
+assert( (fatfs_get_remote_record( DIR_ATTR, base_xp + offset ) == ATTR_LONG_NAME_MASK ),
+"this directory entry must be a LFN\n");
+
+        // invalidate LFN entry
+        hal_remote_sb( base_xp + offset , 0xE5 );
+
+        nb_lfn--;
+    }     
+
+    // copy the modified page to the IOC device
+    error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );   
+    
+    if ( error )
+    {
+        printk("\n[ERROR] in %s : cannot update directory on device\n",
+        __FUNCTION__ );
+        return -1;
+    }
+
+#if DEBUG_FATFS_REMOVE_DENTRY
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_FATFS_REMOVE_DENTRY < cycle )
+printk("\n[%s] thread[%x,%x] exit for <%s> in <%s> directory\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name );
+#endif
+
+    return 0;
+
+}  // end fatfs_remove_dentry
+
+/////////////////////////////////////////////////////////////////////
+error_t fatfs_new_dentry_from_mapper( xptr_t         parent_inode_xp,
+                                      vfs_dentry_t * dentry_ptr )
+{
+    uint32_t       cluster_id;        // directory entry first FATFS cluster
+    uint32_t       size;              // directory entry size
+    bool_t         is_dir;            // directory entry type (file/dir)
+    cxy_t          parent_cxy;        // parent inode cluster  
+    vfs_inode_t  * parent_inode_ptr;  // parent inode local pointer
+    mapper_t     * parent_mapper;     // pointer on parent directory mapper
+    xptr_t         child_inode_xp;    // extended pointer on child inode
+    cxy_t          child_cxy;         // child inode cluster  
+    vfs_inode_t  * child_inode_ptr;   // child inode local pointer
+    error_t        error;
+
+    uint8_t        buf[32];           // FAT32 directory entry local copy
+
+    char           parent_name[CONFIG_VFS_MAX_NAME_LENGTH];     // local parent name copy
+    char           child_name[CONFIG_VFS_MAX_NAME_LENGTH];      // local child name copy
+
+// check arguments
+assert( (parent_inode_xp != XPTR_NULL)  , "parent_inode_xp is NULL\n" );
+assert( (dentry_ptr      != NULL ) , "dentry_ptr is NULL\n" );
+
+    // get parent inode cluster and local pointer
+    parent_cxy       = GET_CXY( parent_inode_xp );
+    parent_inode_ptr = GET_PTR( parent_inode_xp );
+
+    // get child inode cluster and pointers
+    child_inode_xp  = hal_remote_l64( XPTR( parent_cxy , &dentry_ptr->child_xp ) );
+    child_cxy       = GET_CXY( child_inode_xp );
+    child_inode_ptr = GET_PTR( child_inode_xp );
+
+    // get child and parent names
+    vfs_inode_get_name( parent_inode_xp , parent_name );
+    vfs_inode_get_name( child_inode_xp  , child_name );
+
+#if DEBUG_FATFS_NEW_DENTRY_FROM
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+if( DEBUG_FATFS_NEW_DENTRY_FROM < cycle )
 printk("\n[%s]  thread[%x,%x] enter for child <%s> in parent <%s> / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name , parent_name , cycle );
+__FUNCTION__, this->process->pid, this->trdid, child_name , parent_name , cycle );
 #endif
 
     // get local pointer on parent mapper
-    mapper = parent_inode->mapper;
-
-    // get pointer and index in mapper for searched directory entry 
-    error  = fatfs_scan_directory( mapper, name , &entry , &index );
-
-    // return non fatal error if not found
-    if( error )
-    {
-        vfs_inode_get_name( XPTR( local_cxy , parent_inode ) , parent_name );
-        printk("\n[ERROR] in %s : cannot find <%s> entry in <%s> directory mapper\n",
-        __FUNCTION__, name , parent_name, name );
-        return -1;
-    }
-  
-
-    // get relevant infos from FAT32 directory entry
-    cluster = (fatfs_get_record( DIR_FST_CLUS_HI , entry ) << 16) |
-              (fatfs_get_record( DIR_FST_CLUS_LO , entry )      ) ;
-    is_dir  = (fatfs_get_record( DIR_ATTR        , entry ) & ATTR_DIRECTORY);
-    size    =  fatfs_get_record( DIR_FILE_SIZE   , entry );
-
-    // scan list of parent dentries to search the parent_inode
-    bool_t found = false;
-    XLIST_FOREACH( root_xp , iter_xp )
-    {
-        // get pointers on dentry
-        dentry_xp  = XLIST_ELEMENT( iter_xp , vfs_dentry_t , parents );
-        dentry_cxy = GET_CXY( dentry_xp );
-        dentry_ptr = GET_PTR( dentry_xp );
-
-        // get local pointer on current parent directory inode
-        vfs_inode_t * current = hal_remote_lpt( XPTR( dentry_cxy , &dentry_ptr->parent ) );
-
-        // check if current parent is the searched parent
-        if( XPTR( dentry_cxy , current ) == XPTR( local_cxy , parent_inode ) )
-        {
-            found = true;
-            break;
-        }
-    }
-
-    if( found == false )
-    { 
-        vfs_inode_get_name( XPTR( local_cxy , parent_inode ) , parent_name );
-        printk("\n[ERROR] in %s : cannot find <%s> directory in list of parents for <%s>\n",
-        __FUNCTION__, parent_name, name );
-        return -1;
-    }
+    parent_mapper = hal_remote_lpt( XPTR( parent_cxy , &parent_inode_ptr->mapper ) );
+
+    // try to get pointer and index of directory entry in mapper 
+    uint8_t      * entry = NULL;
+    uint32_t       index = 0;
+
+    error  = fatfs_scan_directory( XPTR( parent_cxy , parent_mapper ),
+                                   child_name, 
+                                   &entry,
+                                   &index );
+    
+    // an error can be non fatal, for a new (created) entry
+    if( error )  return -1;
+
+    // get local copy of found directory entry
+    hal_remote_memcpy( XPTR( local_cxy  , buf ),
+                       XPTR( parent_cxy , entry ), 32 );
+
+    // get relevant infos from directory entry
+    cluster_id = (fatfs_get_record( DIR_FST_CLUS_HI , buf ) << 16) |
+                 (fatfs_get_record( DIR_FST_CLUS_LO , buf )      ) ;
+    is_dir     = (fatfs_get_record( DIR_ATTR        , buf ) & ATTR_DIRECTORY );
+    size       =  fatfs_get_record( DIR_FILE_SIZE   , buf );
 
     // update the child inode "type", "size", and "extend" fields
     vfs_inode_type_t type = (is_dir) ? INODE_TYPE_DIR : INODE_TYPE_FILE;
 
-    hal_remote_s32( XPTR( child_inode_cxy , &child_inode_ptr->type   ) , type );
-    hal_remote_s32( XPTR( child_inode_cxy , &child_inode_ptr->size   ) , size );
-    hal_remote_s32( XPTR( child_inode_cxy , &child_inode_ptr->extend ) , cluster );
+    hal_remote_s32( XPTR( child_cxy , &child_inode_ptr->type   ) , type );
+    hal_remote_s32( XPTR( child_cxy , &child_inode_ptr->size   ) , size );
+    hal_remote_s32( XPTR( child_cxy , &child_inode_ptr->extend ) , cluster_id );
 
     // update the dentry "extend" field
-    dentry_ptr->extend = (void *)(intptr_t)index;
-
-#if DEBUG_FATFS_NEW_DENTRY
+    hal_remote_spt( XPTR( parent_cxy , &dentry_ptr->extend ) , (void *)(intptr_t)index );
+
+#if DEBUG_FATFS_NEW_DENTRY_FROM
 cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_FATFS_NEW_DENTRY < cycle )
-printk("\n[%s]  thread[%x,%x] exit for <%s> in <%s> / cluster_id %x / size %d  / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name, parent_name, cluster, size,  cycle );
-#endif
-
-
-#if (DEBUG_FATFS_NEW_DENTRY & 1)
-if( DEBUG_FATFS_NEW_DENTRY < cycle )
-{
-    fatfs_display_fat( 0 , 0 , 64 );
-    fatfs_display_fat( cluster >> 10 ,  (cluster & 0x3FF) , 32 );
-}
+if( DEBUG_FATFS_NEW_DENTRY_FROM < cycle )
+printk("\n[%s]  thread[%x,%x] exit for <%s> in <%s> / cluster_id %x / size %d\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name, cluster_id, size );
+#endif
+
+#if (DEBUG_FATFS_NEW_DENTRY_FROM & 1)
+if( DEBUG_FATFS_NEW_DENTRY_FROM < cycle )
+fatfs_display_fat( cluster_id , 32 );
 #endif
 
     return 0;
 
-}  // end fatfs_new_dentry()
-
-//////////////////////////////////////////////////
-error_t fatfs_update_dentry( vfs_inode_t  * inode,
-                             vfs_dentry_t * dentry,
-                             uint32_t       size )
-{
-    uint8_t  * entry;    // pointer on FAT32 directory entry (array of 32 bytes)
-    uint32_t   index;    // index of FAT32 directory entry in mapper 
-    mapper_t * mapper;   // pointer on directory mapper
-    error_t    error;
-
-    char       dir_name[CONFIG_VFS_MAX_NAME_LENGTH];
+}  // end fatfs_new_dentry_from_mapper()
+
+///////////////////////////////////////////////////////////////////
+error_t fatfs_new_dentry_to_mapper( xptr_t         parent_inode_xp,
+                                    vfs_dentry_t * dentry_ptr )
+{
+    uint32_t       cluster_id;        // directory entry cluster
+    cxy_t          parent_cxy;        // parent inode cluster identifier  
+    vfs_inode_t  * parent_inode_ptr;  // child inode local pointer
+    xptr_t         child_inode_xp;    // extended pointer on child inode
+    cxy_t          child_cxy;         // child inode cluster identifier  
+    vfs_inode_t  * child_inode_ptr;   // child inode local pointer
+    error_t        error;
+
+    char           parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
+    char           child_name[CONFIG_VFS_MAX_NAME_LENGTH];
 
 // check arguments
-assert( (inode  != NULL) , "inode is NULL\n" );
-assert( (dentry != NULL) , "dentry is NULL\n" );
+assert( (parent_inode_xp != XPTR_NULL) , "parent_inode_xp argument is NULL\n" );
+assert( (dentry_ptr      != NULL)      , "dentry_ptr argument NULL\n" );
+
+    // get child inode cluster and local pointer
+    parent_cxy       = GET_CXY( parent_inode_xp );
+    parent_inode_ptr = GET_PTR( parent_inode_xp );
+
+    // get child inode cluster and pointers
+    child_inode_xp  = hal_remote_l64( XPTR( parent_cxy , &dentry_ptr->child_xp ) );
+    child_cxy       = GET_CXY( child_inode_xp );
+    child_inode_ptr = GET_PTR( child_inode_xp );
+
+    // get child and parent names
+    vfs_inode_get_name( parent_inode_xp , parent_name );
+    vfs_inode_get_name( child_inode_xp  , child_name );
+
+#if DEBUG_FATFS_NEW_DENTRY_TO_MAP
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+if( DEBUG_FATFS_NEW_DENTRY_TO_MAP < cycle )
+printk("\n[%s]  thread[%x,%x] enter for child <%s> in parent <%s> / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name , parent_name , cycle );
+#endif
+
+    // 1. allocate one FATFS cluster (update FAT and FSINFO) 
+    error = fatfs_cluster_alloc( 0 , &cluster_id );
+
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot find a free cluster_id\n",
+        __FUNCTION__ );
+        return -1;
+    }
+       
+    // 2. register cluster_id in inode descriptor
+    hal_remote_spt( XPTR( child_cxy , &child_inode_ptr->extend ),
+                    (void*)(intptr_t)cluster_id );
+    
+    // 3. introduce dentry in the directory mapper
+    error = fatfs_add_dentry( parent_inode_xp , dentry_ptr );
+        
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot update parent directory mapper\n",
+        __FUNCTION__ );
+        // TODO release cluster_id [AG]
+        return -1;
+    }
+
+#if DEBUG_FATFS_NEW_DENTRY_TO_MAP
+if( DEBUG_FATFS_NEW_DENTRY_TO_MAP < cycle )
+printk("\n[%s]  thread[%x,%x] exit for <%s> in <%s> / cluster_id %x\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name, cluster_id );
+#endif
+
+    return 0;
+
+}  // end fatfs_new_dentry_to mapper()
+
+
+////////////////////////////////////////////////////////////
+error_t fatfs_update_dentry( xptr_t         parent_inode_xp,
+                             vfs_dentry_t * dentry_ptr )
+{
+    cxy_t         parent_cxy;        // parent directory cluster identifier
+    vfs_inode_t * parent_inode_ptr;  // extended pointer on parent directory inode
+    mapper_t    * parent_mapper_ptr; // local pointer on parent directory mapper
+    xptr_t        parent_mapper_xp;  // extended pointer on parent directory mapper
+    xptr_t        child_inode_xp;    // extended pointer on child inode
+    cxy_t         child_cxy;         // child inode cluster identifier
+    vfs_inode_t * child_inode_ptr;   // extended pointer on child inode
+
+    uint32_t      current_size;      // current size in directory mapper 
+    uint32_t      new_size;          // new size (from child inode) 
+    
+    uint32_t      entry_id;          // directory entry index in parent directory mapper
+    uint32_t      page_id;           // page_index in parent directory mapper
+    uint32_t      offset;            // directory entry offset in page
+    xptr_t        page_xp;           // extended pointer on page descriptor
+    xptr_t        base_xp;           // extended pointer on page base 
+    xptr_t        entry_xp;          // extended pointer on directory entry
+
+    error_t       error;
+
+    char       parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
+    char       child_name[CONFIG_VFS_MAX_NAME_LENGTH];
+
+// check arguments
+assert( (parent_inode_xp  != XPTR_NULL) , "parent_inode_xp argument is NULL\n" );
+assert( (dentry_ptr       != NULL)      , "dentry_ptr argument is NULL\n" );
+
+    // get parent directory cluster ans local pointer
+    parent_inode_ptr = GET_PTR( parent_inode_xp );
+    parent_cxy       = GET_CXY( parent_inode_xp );
+
+    // get extended pointer on child inode
+    child_inode_xp  = hal_remote_l64( XPTR( parent_cxy , &dentry_ptr->child_xp ) );
+
+    // get child and parent names
+    vfs_inode_get_name( parent_inode_xp , parent_name );
+    vfs_inode_get_name( child_inode_xp  , child_name );
 
 #if DEBUG_FATFS_UPDATE_DENTRY
 uint32_t   cycle = (uint32_t)hal_get_cycles();
 thread_t * this  = CURRENT_THREAD;
-vfs_inode_get_name( XPTR( local_cxy , inode ) , dir_name );
 if( DEBUG_FATFS_UPDATE_DENTRY < cycle )
-printk("\n[%s]  thread[%x,%x] enter for <%s/%s> / size %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, dir_name, dentry->name, size, cycle );
-#endif
-
-    // get local pointer on mapper
-    mapper = inode->mapper;
-
-    // get pointer and index in mapper for searched directory entry
-    error  = fatfs_scan_directory( mapper, dentry->name , &entry , &index );
-
-    if( error )
-    { 
-        vfs_inode_get_name( XPTR( local_cxy , inode ) , dir_name );
-        printk("\n[ERROR] in %s : cannot find <%s> in parent mapper <%s>\n",
-        __FUNCTION__, dentry->name, dir_name );
-        return -1;
-    }
-
-    // get current size value
-    uint32_t current_size = fatfs_get_record( DIR_FILE_SIZE , entry );
+printk("\n[%s]  thread[%x,%x] enter for <%s> in <%s> / new_size %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, child_name, parent_name, new_size, cycle );
+#endif
+
+    // get child inode cluster and local pointer
+    child_cxy       = GET_CXY( child_inode_xp );
+    child_inode_ptr = GET_PTR( child_inode_xp );
+ 
+    // get size from child inode
+    new_size = hal_remote_l32( XPTR( child_cxy , &child_inode_ptr->size ) );
+ 
+    // get local and extended pointers on parent directory mapper
+    parent_mapper_ptr = hal_remote_lpt( XPTR( parent_cxy , &parent_inode_ptr->mapper ) );
+    parent_mapper_xp  = XPTR( parent_cxy , parent_mapper_ptr );
+
+    // get directory entry index from dentry extension
+    entry_id = (intptr_t)hal_remote_lpt( XPTR( parent_cxy , &dentry_ptr->extend ) );
+
+    // get page index and offset in parent directory mapper
+    page_id  = entry_id >> 7;
+    offset   = (entry_id & 0x7F) << 5;
+
+    // get extended pointers on page descriptor and page base
+    page_xp = mapper_get_page( parent_mapper_xp , page_id );     
+    base_xp = ppm_page2base( page_xp ); 
+
+    // build extended pointer on directory entry
+    entry_xp = base_xp + offset;
+
+    // get current size from directory mapper
+    current_size = fatfs_get_remote_record( DIR_FILE_SIZE , entry_xp );
 
     // update dentry in mapper & device only if required
-    if( size != current_size )
+    if( new_size != current_size )
     {
         // set size field in FAT32 directory entry
-        fatfs_set_record( DIR_FILE_SIZE , entry , size );
-
-        // get pointer on modified page base
-        void * base = (void *)((intptr_t)entry & (~CONFIG_PPM_PAGE_MASK)); 
-
-        // get extended pointer on modified page descriptor
-        xptr_t page_xp = ppm_base2page( XPTR( local_cxy , base ) );
-
-        // synchronously update the modified page on device
+        fatfs_set_remote_record( DIR_FILE_SIZE , entry_xp , new_size );
+
+        // synchronously update the modified mapper page on device
         error = fatfs_move_page( page_xp , IOC_SYNC_WRITE );
 
         if( error )
         { 
-            vfs_inode_get_name( XPTR( local_cxy , inode ) , dir_name );
             printk("\n[ERROR] in %s : cannot update parent directory <%s> on device\n",
-            __FUNCTION__, dir_name );
+            __FUNCTION__, parent_name );
             return -1;
         }
